
//	NeuralNet consists of two functions:
//	NeuralNetBP  is a standard back propogation using steepest descent technique
//	NeuralNetRP  is with Resilient Propogation RPROP for fast learning

// there may be instances when one method works better than other. So both are kept

#include "windows.h"
#include "avisynth.h"
#include <cmath>

#include "NeuralNetBP.cpp"
#include "NeuralNetRP.cpp"
#include "NeuralNetLN.cpp"



extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env)
{
    env->AddFunction("NeuralNetBP", "cc[sf]i[ef]i[lx]i[ty]i[rx]i[by]i[elx]i[ety]i[erx]i[eby]i"
		"[white]b[xpts]i[ypts]i[tlx]i[tty]i[trx]i[tby]i[thresh]i[tf]i[wh]f[wo]f[iter]i"
		"[test]b[minstep]f[wset]i[cwt]i[hnodes]i[bestof]i[activate]s[line]b", Create_NeuralNetBP, 0);

	env->AddFunction("NeuralNetRP", "cc[sf]i[ef]i[lx]i[ty]i[rx]i[by]i[elx]i[ety]i[erx]i[eby]i"
		"[white]b[xpts]i[ypts]i[tlx]i[tty]i[trx]i[tby]i[thresh]i[tf]i[wh]f[wo]f[iter]i"
		"[test]b[plot]s[wset]i[nplot]i[hnodes]i[bestof]i[activate]s[line]b", Create_NeuralNetRP, 0);

	env->AddFunction("NeuralNetLN", "cc[sf]i[ef]i[lx]i[ty]i[rx]i[by]i[elx]i[ety]i[erx]i[eby]i"
		"[xpts]i[ypts]i[tlx]i[tty]i[trx]i[tby]i[tf]i[wh]f[iter]i"
		"[wset]i[bestof]i[line]b", Create_NeuralNetLN, 0);

					
    return "NeuralNet  Plugin";
}